<script setup lang="ts">
import { useRoute } from 'vue-router';
import { reactive, ref, onMounted, toRaw } from 'vue';
import { PageContainer } from '@ant-design-vue/pro-layout';
import { message, Modal, Form, notification } from 'ant-design-vue/lib';
import { SizeType } from 'ant-design-vue/lib/config-provider';
import { MenuInfo } from 'ant-design-vue/lib/menu/src/interface';
import { ColumnsType } from 'ant-design-vue/lib/table';
import UploadModal from '@/components/UploadModal/index.vue';
import {
  listAuth,
  getAuth,
  updateAuth,
  addAuth,
  delAuth,
  loadAuth,
  exportAuth,
  importAuthData,
  batchAuth,
  batchDelAuth,
} from '@/api/neUser/auth';
import useNeInfoStore from '@/store/modules/neinfo';
import useI18n from '@/hooks/useI18n';
import { RESULT_CODE_SUCCESS } from '@/constants/result-constants';
import { saveAs } from 'file-saver';
const { t } = useI18n();
const route = useRoute();

/**路由标题 */
let title = ref<string>((route.meta.title as string) ?? '标题');

/**网元参数 */
let neOtions = ref<Record<string, any>[]>([]);

/**查询参数 */
let queryParams = reactive({
  /**网元ID */
  neId: undefined,
  /**移动编号 */
  imsi: '',
  /**排序字段 */
  sortField: 'imsi',
  /**排序方式 */
  sortOrder: 'asc',
  /**当前页数 */
  pageNum: 1,
  /**每页条数 */
  pageSize: 20,
});

/**查询参数重置 */
function fnQueryReset() {
  queryParams = Object.assign(queryParams, {
    imsi: '',
    sortField: 'imsi',
    sortOrder: 'asc',
    pageNum: 1,
    pageSize: 20,
  });
  tablePagination.current = 1;
  tablePagination.pageSize = 20;
  fnGetList();
}

/**表格状态类型 */
type TabeStateType = {
  /**加载等待 */
  loading: boolean;
  /**紧凑型 */
  size: SizeType;
  /**搜索栏 */
  seached: boolean;
  /**记录数据 */
  data: object[];
};

/**表格状态 */
let tableState: TabeStateType = reactive({
  loading: false,
  size: 'middle',
  seached: true,
  data: [],
});

/**表格字段列 */
let tableColumns: ColumnsType = [
  {
    title: 'IMSI',
    dataIndex: 'imsi',
    align: 'center',
  },
  {
    title: 'AMF',
    dataIndex: 'amf',
    align: 'center',
  },
  {
    title: 'STATUS',
    dataIndex: 'status',
    align: 'center',
  },
  {
    title: 'KI',
    dataIndex: 'ki',
    align: 'center',
  },
  {
    title: 'OPC',
    dataIndex: 'opc',
    align: 'center',
  },
  {
    title: 'ALGO_INDEX',
    dataIndex: 'algoIndex',
    align: 'center',
  },
  {
    title: t('common.operate'),
    key: 'imsi',
    align: 'center',
  },
];

/**表格分页器参数 */
let tablePagination = reactive({
  /**当前页数 */
  current: 1,
  /**每页条数 */
  pageSize: 20,
  /**默认的每页条数 */
  defaultPageSize: 20,
  /**指定每页可以显示多少条 */
  pageSizeOptions: ['10', '20', '50', '100'],
  /**只有一页时是否隐藏分页器 */
  hideOnSinglePage: false,
  /**是否可以快速跳转至某页 */
  showQuickJumper: true,
  /**是否可以改变 pageSize */
  showSizeChanger: true,
  /**数据总数 */
  total: 0,
  showTotal: (total: number) => t('common.tablePaginationTotal', { total }),
  onChange: (page: number, pageSize: number) => {
    tablePagination.current = page;
    tablePagination.pageSize = pageSize;
    queryParams.pageNum = page;
    queryParams.pageSize = pageSize;
    fnGetList();
  },
});

/**表格紧凑型变更操作 */
function fnTableSize({ key }: MenuInfo) {
  tableState.size = key as SizeType;
}

/**对话框对象信息状态类型 */
type ModalStateType = {
  /**详情框是否显示 */
  visibleByView: boolean;
  /**新增框或修改框是否显示 */
  visibleByEdit: boolean;
  /**批量新增新增框是否显示 */
  visibleByBatch: boolean;
  /**批量新增删除框是否显示 */
  visibleByBatchDel: boolean;
  /**标题 */
  title: string;
  /**表单数据 */
  from: Record<string, any>;
  /**表单数据 */
  BatchForm: Record<string, any>;
  /**表单数据 */
  BatchDelForm: Record<string, any>;
  /**确定按钮 loading */
  confirmLoading: boolean;
  /**更新加载数据按钮 loading */
  loadDataLoading: boolean;
};

/**对话框对象信息状态 */
let modalState: ModalStateType = reactive({
  visibleByView: false,
  visibleByEdit: false,
  visibleByBatch: false,
  visibleByBatchDel: false,
  title: 'UDM鉴权用户',
  from: {
    id: '',
    imsi: '',
    amf: '',
    ki: '',
    algoIndex: '',
    opc: '',
  },
  BatchForm: {
    num: '',
    imsi: '',
    amf: '',
    ki: '',
    algoIndex: '',
    opc: '',
  },
  BatchDelForm: {
    num: '',
    imsi: '',
  },
  confirmLoading: false,
  loadDataLoading: false,
});

/**对话框内表单属性和校验规则 */
const modalStateFrom = Form.useForm(
  modalState.from,
  reactive({
    imsi: [{ required: true, message: 'IMSI不能为空' }],
    amf: [{ required: true, message: 'AMF不能为空' }],
    ki: [{ required: true, message: 'KI不能为空' }],
    algo: [{ required: true, message: 'algoIndex不能为空' }],
    opc: [{ required: true, message: 'OPC能为空' }],
  })
);

/**对话框内批量添加表单属性和校验规则 */
const modalStateBatchFrom = Form.useForm(
  modalState.BatchForm,
  reactive({
    num: [
      { required: true, message: '放号数不能为空' },
      { min: 1, max: 100, message: '放号数必须小于等于100' },
    ],
    imsi: [{ required: true, message: 'IMSI不能为空' }],
    amf: [{ required: true, message: 'AMF不能为空' }],
    ki: [{ required: true, message: 'KI不能为空' }],
    algo: [{ required: true, message: 'algoIndex不能为空' }],
    opc: [{ required: true, message: 'OPC能为空' }],
  })
);

/**对话框内批量删除表单属性和校验规则 */
const modalStateBatchDelFrom = Form.useForm(
  modalState.BatchDelForm,
  reactive({
    num: [
      { required: true, message: '删除个数不能为空' },
      { min: 1, max: 100, message: '删除个数必须小于等于100' },
    ],
    imsi: [{ required: true, message: '起始IMSI不能为空' }],
  })
);

/**
 * 对话框弹出显示为 新增或者修改
 * @param noticeId 网元id, 不传为新增
 */
function fnModalVisibleByEdit(row?: Record<string, any>) {
  if (!row) {
    modalStateFrom.resetFields(); //重置表单
    modalState.title = '添加鉴权信息';
    modalState.visibleByEdit = true;
  } else {
    if (modalState.confirmLoading) return;
    const hide = message.loading('正在打开...', 0);
    modalState.confirmLoading = true;
    const neID = queryParams.neId || '-';
    getAuth(neID, row?.imsi).then(res => {
      modalState.confirmLoading = false;
      hide();
      if (res.code === RESULT_CODE_SUCCESS) {
        modalState.from = Object.assign(modalState.from, res.data);
        modalState.title = '修改鉴权信息';
        modalState.visibleByEdit = true;
      } else {
        message.error(`获取鉴权信息失败`, 2);
      }
    });
  }
}

/**
 * 对话框弹出显示为 批量新增,批量删除
 * @param noticeId 网元id, 不传为新增
 */
function fnModalVisibleByBatch(batchFlag?: number) {
  if (batchFlag) {
    modalStateBatchFrom.resetFields(); //重置表单
    modalState.title = '批量添加鉴权信息';
    modalState.visibleByBatch = true;
  } else {
    modalStateBatchFrom.resetFields(); //重置表单
    modalState.title = '批量删除鉴权信息';
    modalState.visibleByBatchDel = true;
  }
}

/**
 * 对话框弹出确认执行函数
 * 进行表达规则校验
 */
function fnModalOk() {
  const neID = queryParams.neId;
  if (!neID) return;
  modalStateFrom
    .validate()
    .then(e => {
      modalState.confirmLoading = true;
      const from = toRaw(modalState.from);
      from.neId = neID;
      const result = from.id ? updateAuth(from) : addAuth(from);
      const hide = message.loading({ content: t('common.loading') });
      result
        .then(res => {
          if (res.code === RESULT_CODE_SUCCESS) {
            message.success({
              content: t('common.msgSuccess', { msg: modalState.title }),
              duration: 3,
            });
            modalState.visibleByEdit = false;
            modalStateFrom.resetFields();
            fnGetList();
          } else {
            message.error({
              content: `${res.msg}`,
              duration: 3,
            });
          }
        })
        .finally(() => {
          hide();
          modalState.confirmLoading = false;
        });
    })
    .catch(e => {
      message.error(t('common.errorFields', { num: e.errorFields.length }), 3);
    });
}

/**
 * 对话框弹出 批量新增操作确认执行函数
 * 进行表达规则校验
 */
function fnBatchModalOk() {
  modalStateBatchFrom
    .validate()
    .then(e => {
      modalState.confirmLoading = true;
      const from = toRaw(modalState.BatchForm);
      const neID = queryParams.neId || '-';
      // const result = from.id ? updateAuth(from) : addAuth(neID, from);
      from.neID = neID;
      const result = batchAuth(from);
      const hide = message.loading({ content: t('common.loading') });
      result
        .then(res => {
          if (res.code === RESULT_CODE_SUCCESS) {
            message.success({
              content: t('common.msgSuccess', { msg: modalState.title }),
              duration: 3,
            });
            modalState.visibleByBatch = false;
            modalStateBatchFrom.resetFields();
            fnGetList();
          } else {
            message.error({
              content: `${res.msg}`,
              duration: 3,
            });
          }
        })
        .finally(() => {
          hide();
          modalState.confirmLoading = false;
        });
    })
    .catch(e => {
      message.error(t('common.errorFields', { num: e.errorFields.length }), 3);
    });
}

/**
 * 对话框弹出 批量删除确认执行函数
 * 进行表达规则校验
 */
function fnBatchDelModalOk() {
  modalStateBatchDelFrom
    .validate()
    .then(e => {
      modalState.confirmLoading = true;
      const from = toRaw(modalState.BatchDelForm);

      const neID = queryParams.neId || '-';
      // const result = from.id ? updateAuth(from) : addAuth(neID, from);
      from.neID = neID;
      const result = batchDelAuth(from);
      const hide = message.loading({ content: t('common.loading') });
      result
        .then(res => {
          if (res.code === RESULT_CODE_SUCCESS) {
            message.success({
              content: t('common.msgSuccess', { msg: modalState.title }),
              duration: 3,
            });
            modalState.visibleByBatchDel = false;
            modalStateBatchDelFrom.resetFields();
            fnGetList();
          } else {
            message.error({
              content: `${res.msg}`,
              duration: 3,
            });
          }
        })
        .finally(() => {
          hide();
          modalState.confirmLoading = false;
        });
    })
    .catch(e => {
      message.error(t('common.errorFields', { num: e.errorFields.length }), 3);
    });
}

/**
 * 批量添加对话框弹出关闭执行函数
 * 进行表达规则校验
 */
function fnBatchModalCancel() {
  modalState.visibleByBatch = false;
  modalState.visibleByView = false;
  modalStateBatchFrom.resetFields();
}

/**
 * 批量删除对话框弹出关闭执行函数
 * 进行表达规则校验
 */
function fnBatchDelModalCancel() {
  modalState.visibleByBatchDel = false;
  modalState.visibleByView = false;
  modalStateBatchDelFrom.resetFields();
}

/**
 * 对话框弹出关闭执行函数
 * 进行表达规则校验
 */
function fnModalCancel() {
  modalState.visibleByEdit = false;
  modalState.visibleByView = false;
  modalStateFrom.resetFields();
}

/**
 * UDM鉴权用户删除
 * @param row 网元编号ID
 */
function fnRecordDelete(row: Record<string, any>) {
  Modal.confirm({
    title: '提示',
    content: `确认删除IMSI编号为: ${row.imsi} 的用户嘛?`,
    onOk() {
      const key = 'delNotice';
      message.loading({ content: '请稍等...', key });
      const neID = queryParams.neId || '-';
      delAuth(neID, row).then(res => {
        if (res.code === RESULT_CODE_SUCCESS) {
          message.success({
            content: `删除成功`,
            key,
            duration: 2,
          });
          fnGetList();
        } else {
          message.error({
            content: `${res.msg}`,
            key: key,
            duration: 2,
          });
        }
      });
    },
  });
}

/**列表导出 */
function fnExportList(type: string) {
  const neID = queryParams.neId;
  if (!neID) return;
  const key = 'exportAuth';
  message.loading({ content: '请稍等...', key });
  exportAuth({
    neId: neID,
    type: type,
  }).then(res => {
    if (res.code === RESULT_CODE_SUCCESS) {
      message.success({
        content: `已完成导出`,
        key,
        duration: 2,
      });
      saveAs(res.data, `UDMAuth_${Date.now()}.${type}`);
    } else {
      message.error({
        content: `${res.msg}`,
        key,
        duration: 2,
      });
    }
  });
}

/**重新加载数据 */
function fnLoadData() {
  const neID = queryParams.neId;
  if (tableState.loading || !neID) return;
  modalState.loadDataLoading = true;
  tablePagination.total = 0;
  tableState.data = [];
  tableState.loading = true; // 表格loading
  loadAuth(neID).then(res => {
    if (res.code === RESULT_CODE_SUCCESS) {
      notification.success({
        message: t('views.neUser.auth.loadData'),
        description: t('views.neUser.auth.loadDataTip', { num: res.data }),
        duration: 10,
      });
      // 延迟3s后关闭loading刷新列表
      setTimeout(() => {
        modalState.loadDataLoading = false;
        tableState.loading = false; // 表格loading
        fnQueryReset();
      }, 3000);
    } else {
      message.error({
        content: `获取数据失败`,
        duration: 3,
      });
    }
  });
}

/**查询网元列表 */
function fnGetList() {
  if (tableState.loading) return;
  tableState.loading = true;
  listAuth(toRaw(queryParams)).then(res => {
    if (res.code === RESULT_CODE_SUCCESS && Array.isArray(res.rows)) {
      tablePagination.total = res.total;
      tableState.data = res.rows;
    }
    tableState.loading = false;
  });
}

/**对话框表格信息导入对象信息状态类型 */
type ModalUploadImportStateType = {
  /**是否显示 */
  visible: boolean;
  /**标题 */
  title: string;
  /**是否上传中 */
  loading: boolean;
  /**上传结果信息 */
  msg: string;
};

/**对话框表格信息导入对象信息状态 */
let uploadImportState: ModalUploadImportStateType = reactive({
  visible: false,
  title: '数据导入',
  loading: false,
  msg: '',
});

/**对话框表格信息导入弹出窗口 */
function fnModalUploadImportOpen() {
  uploadImportState.msg = '';
  uploadImportState.loading = false;
  uploadImportState.visible = true;
}

/**对话框表格信息导入关闭窗口 */
function fnModalUploadImportClose() {
  uploadImportState.visible = false;
  fnGetList();
}

/**对话框表格信息导入上传 */
function fnModalUploadImportUpload(file: File) {
  let formData = new FormData();
  formData.append('file', file);
  const neID = queryParams.neId;
  if (!neID) {
    return Promise.reject('未知网元');
  }
  const hide = message.loading('正在上传...', 0);
  uploadImportState.loading = true;
  importAuthData(neID, formData)
    .then(res => {
      uploadImportState.msg = res.msg;
    })
    .catch((err: { code: number; msg: string }) => {
      message.error(`上传失败 ${err.msg}`);
    })
    .finally(() => {
      hide();
      uploadImportState.loading = false;
    });
}

onMounted(() => {
  // 获取网元网元列表
  useNeInfoStore()
    .fnNelist()
    .then(res => {
      if (res.code === RESULT_CODE_SUCCESS && Array.isArray(res.data)) {
        if (res.data.length > 0) {
          let arr: Record<string, any>[] = [];
          res.data.forEach(i => {
            if (i.neType === 'UDM') {
              arr.push({ value: i.neId, label: i.neName });
            }
          });
          neOtions.value = arr;
          if (arr.length > 0) {
            queryParams.neId = arr[0].value;
          }
        }
      } else {
        message.warning({
          content: `暂无网元列表数据`,
          duration: 2,
        });
      }
    })
    .finally(() => {
      // 获取列表数据
      fnGetList();
    });
});
</script>

<template>
  <PageContainer :title="title">
    <a-card
      v-show="tableState.seached"
      :bordered="false"
      :body-style="{ marginBottom: '24px', paddingBottom: 0 }"
    >
      <!-- 表格搜索栏 -->
      <a-form :model="queryParams" name="queryParams" layout="horizontal">
        <a-row :gutter="16">
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item :label="t('views.neUser.auth.neType')" name="neId ">
              <a-select
                v-model:value="queryParams.neId"
                :options="neOtions"
                allow-clear
                :placeholder="t('views.neUser.auth.neTypePlease')"
              />
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item label="IMSI" name="imsi">
              <a-input
                v-model:value="queryParams.imsi"
                allow-clear
                placeholder="查询IMSI"
              ></a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item>
              <a-space :size="8">
                <a-button type="primary" @click.prevent="fnGetList">
                  <template #icon>
                    <SearchOutlined />
                  </template>
                  {{ t('common.search') }}
                </a-button>
                <a-button type="default" @click.prevent="fnQueryReset">
                  <template #icon>
                    <ClearOutlined />
                  </template>
                  {{ t('common.reset') }}
                </a-button>
              </a-space>
            </a-form-item>
          </a-col>
        </a-row>
      </a-form>
    </a-card>

    <a-card :bordered="false" :body-style="{ padding: '0px' }">
      <!-- 插槽-卡片左侧侧 -->
      <template #title>
        <a-space :size="8" align="center">
          <a-button type="primary" @click.prevent="fnModalVisibleByEdit()">
            <template #icon>
              <PlusOutlined />
            </template>
            {{ t('common.addText') }}
          </a-button>

          <a-button type="primary" @click.prevent="fnModalVisibleByBatch(1)">
            <template #icon>
              <PlusOutlined />
            </template>
            {{ t('views.neUser.auth.batchAddText') }}
          </a-button>
          <a-button
            type="primary"
            danger
            ghost
            @click.prevent="fnModalVisibleByBatch(0)"
          >
            <template #icon>
              <DeleteOutlined />
            </template>
            {{ t('views.neUser.auth.batchDelText') }}
          </a-button>
          <a-popconfirm
            :title="t('views.neUser.auth.loadDataConfirm')"
            :ok-text="t('common.ok')"
            :cancel-text="t('common.cancel')"
            :disabled="modalState.loadDataLoading"
            @confirm="fnLoadData"
          >
            <a-button
              type="dashed"
              danger
              :disabled="modalState.loadDataLoading"
              :loading="modalState.loadDataLoading"
            >
              <template #icon><SyncOutlined /></template>
              {{ t('views.neUser.auth.loadData') }}
            </a-button>
          </a-popconfirm>

          <a-button type="dashed" @click.prevent="fnModalUploadImportOpen">
            <template #icon><ImportOutlined /></template>
            {{ t('views.neUser.auth.import') }}
          </a-button>

          <a-popconfirm
            :title="t('views.neUser.auth.exportConfirm')"
            ok-text="TXT"
            ok-type="default"
            @confirm="fnExportList('txt')"
            cancel-text="CSV"
            @cancel="fnExportList('csv')"
          >
            <a-button type="dashed">
              <template #icon><ExportOutlined /></template>
              {{ t('views.neUser.auth.export') }}
            </a-button>
          </a-popconfirm>
        </a-space>
      </template>

      <!-- 插槽-卡片右侧 -->
      <template #extra>
        <a-space :size="8" align="center">
          <a-tooltip>
            <template #title>{{ t('common.searchBarText') }}</template>
            <a-switch
              v-model:checked="tableState.seached"
              :checked-children="t('common.switch.show')"
              :un-checked-children="t('common.switch.hide')"
              size="small"
            />
          </a-tooltip>
          <a-tooltip>
            <template #title>{{ t('common.reloadText') }}</template>
            <a-button type="text" @click.prevent="fnGetList">
              <template #icon>
                <ReloadOutlined />
              </template>
            </a-button>
          </a-tooltip>
          <a-tooltip>
            <template #title>{{ t('common.sizeText') }}</template>
            <a-dropdown trigger="click">
              <a-button type="text">
                <template #icon>
                  <ColumnHeightOutlined />
                </template>
              </a-button>
              <template #overlay>
                <a-menu
                  :selected-keys="[tableState.size as string]"
                  @click="fnTableSize"
                >
                  <a-menu-item key="default">{{
                    t('common.size.default')
                  }}</a-menu-item>
                  <a-menu-item key="middle">{{
                    t('common.size.middle')
                  }}</a-menu-item>
                  <a-menu-item key="small">{{
                    t('common.size.small')
                  }}</a-menu-item>
                </a-menu>
              </template>
            </a-dropdown>
          </a-tooltip>
        </a-space>
      </template>

      <!-- 表格列表 -->
      <a-table
        class="table"
        row-key="imsi"
        :columns="tableColumns"
        :loading="tableState.loading"
        :data-source="tableState.data"
        :size="tableState.size"
        :pagination="tablePagination"
        :scroll="{ x: true }"
      >
        <template #bodyCell="{ column, record }">
          <template v-if="column.key === 'imsi'">
            <a-space :size="8" align="center">
              <a-tooltip>
                <template #title>{{ t('common.editText') }}</template>
                <a-button
                  type="link"
                  @click.prevent="fnModalVisibleByEdit(record)"
                >
                  <template #icon>
                    <FormOutlined />
                  </template>
                </a-button>
              </a-tooltip>
              <a-tooltip>
                <template #title>{{ t('common.deleteText') }}</template>
                <a-button type="link" @click.prevent="fnRecordDelete(record)">
                  <template #icon>
                    <DeleteOutlined />
                  </template>
                </a-button>
              </a-tooltip>
            </a-space>
          </template>
        </template>
      </a-table>
    </a-card>

    <!-- 新增框或修改框 -->
    <a-modal
      width="800px"
      :keyboard="false"
      :mask-closable="false"
      :visible="modalState.visibleByEdit"
      :title="modalState.title"
      :confirm-loading="modalState.confirmLoading"
      @ok="fnModalOk"
      @cancel="fnModalCancel"
    >
      <a-form
        name="modalStateFrom"
        layout="horizontal"
        :label-col="{ span: 7 }"
      >
        <a-row :gutter="16">
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              label="IMSI"
              name="imsi"
              v-bind="modalStateFrom.validateInfos.imsi"
            >
              <a-input
                v-model:value="modalState.from.imsi"
                :disabled="modalState.from.id != ''"
                allow-clear
                placeholder="请输入IMSI"
              >
                <!-- <template #prefix>
                  <a-tooltip placement="topLeft">
                    <template #title> 填写创建的网元类型,如:SMF </template>
                    <InfoCircleOutlined style="color: rgba(0, 0, 0, 0.45)" />
                  </a-tooltip>
                </template> -->
              </a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              label="AMF"
              name="amf"
              v-bind="modalStateFrom.validateInfos.amf"
            >
              <a-input
                v-model:value="modalState.from.amf"
                allow-clear
                placeholder="请输入AMF"
              ></a-input>
            </a-form-item>
          </a-col>
        </a-row>

        <a-row :gutter="16">
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              label="KI"
              name="ki"
              v-bind="modalStateFrom.validateInfos.ki"
            >
              <a-input
                v-model:value="modalState.from.ki"
                allow-clear
                placeholder="请输入KI"
              >
              </a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              label="Algo Index"
              name="algo"
              v-bind="modalStateFrom.validateInfos.algo"
            >
              <a-input
                v-model:value="modalState.from.algoIndex"
                allow-clear
                placeholder="请输入Algo Index"
              >
              </a-input>
            </a-form-item>
          </a-col>
        </a-row>

        <a-row :gutter="16">
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              label="OPC"
              name="opc"
              v-bind="modalStateFrom.validateInfos.opc"
            >
              <a-input
                v-model:value="modalState.from.opc"
                allow-clear
                placeholder="请输入OPC"
              ></a-input>
            </a-form-item>
          </a-col>
        </a-row>
      </a-form>
    </a-modal>

    <!-- 批量新增框 -->
    <a-modal
      width="800px"
      :keyboard="false"
      :mask-closable="false"
      :visible="modalState.visibleByBatch"
      :title="modalState.title"
      :confirm-loading="modalState.confirmLoading"
      @ok="fnBatchModalOk"
      @cancel="fnBatchModalCancel"
    >
      <a-form
        name="modalStateBatchFrom"
        layout="horizontal"
        :label-col="{ span: 7 }"
      >
        <a-row :gutter="16">
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              :label="t('views.neUser.auth.num')"
              name="num"
              v-bind="modalStateBatchFrom.validateInfos.num"
            >
              <a-input
                v-model:value="modalState.BatchForm.num"
                allow-clear
                placeholder="请输入放号数"
              ></a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              label="IMSI"
              name="imsi"
              v-bind="modalStateBatchFrom.validateInfos.imsi"
            >
              <a-input
                v-model:value="modalState.BatchForm.imsi"
                allow-clear
                placeholder="请输入IMSI"
              >
                <!-- <template #prefix>
                  <a-tooltip placement="topLeft">
                    <template #title> 填写创建的网元类型,如:SMF </template>
                    <InfoCircleOutlined style="color: rgba(0, 0, 0, 0.45)" />
                  </a-tooltip>
                </template> -->
              </a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              label="AMF"
              name="amf"
              v-bind="modalStateBatchFrom.validateInfos.amf"
            >
              <a-input
                v-model:value="modalState.BatchForm.amf"
                allow-clear
                placeholder="请输入AMF"
              ></a-input>
            </a-form-item>
          </a-col>
        </a-row>

        <a-row :gutter="16">
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              label="KI"
              name="ki"
              v-bind="modalStateBatchFrom.validateInfos.ki"
            >
              <a-input
                v-model:value="modalState.BatchForm.ki"
                allow-clear
                placeholder="请输入KI"
              >
              </a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              label="Algo Index"
              name="algo"
              v-bind="modalStateBatchFrom.validateInfos.algo"
            >
              <a-input
                v-model:value="modalState.BatchForm.algoIndex"
                allow-clear
                placeholder="请输入Algo Index"
              >
              </a-input>
            </a-form-item>
          </a-col>
        </a-row>

        <a-row :gutter="16">
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              label="OPC"
              name="opc"
              v-bind="modalStateBatchFrom.validateInfos.opc"
            >
              <a-input
                v-model:value="modalState.BatchForm.opc"
                allow-clear
                placeholder="请输入OPC"
              ></a-input>
            </a-form-item>
          </a-col>
        </a-row>
      </a-form>
    </a-modal>

    <!-- 批量删除框 -->
    <a-modal
      width="1000px"
      :keyboard="false"
      :mask-closable="false"
      :visible="modalState.visibleByBatchDel"
      :title="modalState.title"
      :confirm-loading="modalState.confirmLoading"
      @ok="fnBatchDelModalOk"
      @cancel="fnBatchDelModalCancel"
    >
      <a-form
        name="modalStateBatchDelFrom"
        layout="horizontal"
        :label-col="{ span: 7.5 }"
        :labelWrap="true"
      >
        <a-row :gutter="16">
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              :label="t('views.neUser.sub.num')"
              name="num"
              v-bind="modalStateBatchDelFrom.validateInfos.num"
            >
              <a-input
                v-model:value="modalState.BatchDelForm.num"
                allow-clear
                placeholder="请输入删号个数"
              ></a-input>
            </a-form-item>
          </a-col>

          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              :label="t('views.neUser.sub.startIMSI')"
              name="imsi"
              v-bind="modalStateBatchDelFrom.validateInfos.imsi"
            >
              <a-input
                v-model:value="modalState.BatchDelForm.imsi"
                allow-clear
                placeholder="请输入起始IMSI"
              >
                <template #prefix>
                  <a-tooltip placement="topLeft">
                    <template #title>
                      SUPI=MCC+MNC+MSIN MCC=移动国家号码, 由三位数字组成
                      MNC=移动网络号，由两位数字组成
                      MSIN=移动客户识别码,采用等长10位数字构成
                    </template>
                    <InfoCircleOutlined style="color: rgba(0, 0, 0, 0.45)" />
                  </a-tooltip>
                </template>
              </a-input>
            </a-form-item>
          </a-col>
        </a-row>
      </a-form>
    </a-modal>

    <!-- 上传导入表格数据文件框 -->
    <UploadModal
      :title="uploadImportState.title"
      :loading="uploadImportState.loading"
      @upload="fnModalUploadImportUpload"
      @close="fnModalUploadImportClose"
      v-model:visible="uploadImportState.visible"
      :ext="['.csv', '.txt']"
      :size="5"
    >
      <template #default>
        <a-textarea
          :disabled="true"
          :hidden="!uploadImportState.msg"
          :value="uploadImportState.msg"
          :auto-size="{ minRows: 2, maxRows: 8 }"
        />
      </template>
    </UploadModal>
  </PageContainer>
</template>

<style lang="less" scoped>
.table :deep(.ant-pagination) {
  padding: 0 24px;
}
</style>
